// Wojciech Grzekowiak, Album: 200884, Grupa: G1ISIII
// Opis kontenera Vector.

#include<iostream>
#include<algorithm>
#include<boost/assert.hpp> 
// Ay uywac kontenera std:vector naley doczy plika nagwkowy vector.
#include<vector>

using namespace std;

// Szablon funkcji do wypisywania wszystkich elementw
// vectorw niezalenie od tego jakie obiekty trzymaj.
template<class T> void printVector(const vector<T> & _v)
{
	// size() zwraca nam liczb elementw w vektorze.
	for(int i = 0; i < _v.size(); ++i)
		cout << _v[i] << ' ';
	cout << endl;
}

// Gowna funkcja.
int main()
{
	// Tworzymy pusty vector liczb.
	vector<int> liczby1;

	// Dodajemy do kontenera liczby1 9, 8, 7 ...
	// gdzie kada kolejna wrzucana jest na koniec.
	for(int i = 9; i >= 0; --i)
		liczby1.push_back(i);

	// W tym momencie nasz vector wyglda tak:
	// Indeks:  [0|1|2|3|4|5|6|7|8|9]
	// Warto: [9|8|7|6|5|6|3|2|1|0]
	// Size:	10

	cout << "Liczby1: "; printVector<int>(liczby1);

	// Wycignicie liczby z pod indeksu mona zrobic na dwojaki sposb:
	int liczba6_s1 = liczby1[6];		// Tutaj korzystamy z operatora [indeks].
	int liczba6_s2 = liczby1.at(6);		// Tutaj korzystamy z funkcji at(indeks).

	// To s te same liczby.
	BOOST_ASSERT(liczba6_s1 == liczba6_s2);
	
	// Tworzymy nowy vector liczby kopiujc elementy z starego.
	vector<int> liczby2(liczby1);

	// Mamy wic identyczny vektor liczb.
	// Zwiekszmy jego rozmiar (size).
	liczby2.resize(liczby2.size() + 5, 33);

	// Funkcja size() zwrcia nam liczb elementw w vekorze. Bya ich tam 10.
	// Zwiekszylimy rozmiar do 15, wiec dodano 5 elementw o wartoci 
	// przekazanej w drugim parametrze czyli 33. Nasz vector liczby2 wyglda teraz
	// nastpujco:
	// Indeks:  [0|1|2|3|4|5|6|7|8|9|10|11|12|13|14]
	// Warto: [9|8|7|6|5|6|3|2|1|0|33|33|33|33|33]
	// Size:	15

	cout << "Liczby2: "; printVector<int>(liczby2);

	// Teraz chcielibymy wszystkie lementy z vektora ilczby1 przeniesc
	// do liczby2 i odwrotnie. Za nas zrobi to funkcja swap().
	liczby1.swap(liczby2);

	cout << "Liczby1: "; printVector<int>(liczby1);
	cout << "Liczby2: "; printVector<int>(liczby2);

	// Vektory mona take atwo posrotowa, uywajc algorytmw sortowania.
	// Aby ich uy naley poda zakres liczb do sortowania, zakres ten
	// podaje si wykorzystujc iteratory. start() zwraca iterator wskazujcy
	// na pocztek vektora, end() na koniec.
	sort(liczby1.begin(), liczby1.end());

	// Nasze liczby s ju posortowane.
	// Indeks:  [0|1|2|3|4|5|6|7|8|9|10|11|12|13|14]
	// Warto: [0|1|2|3|4|5|6|7|8|9|33|33|33|33|33]
	cout << "Liczby1: "; printVector<int>(liczby1);

	// Uwrzmy kolejny vector, kopiuj cniektore elmenty z poprzedniego.
	// Kopiujemy wszystko oprcz 4 pierwszych i 2 ostatnich elementw,
	// podajac wasnie takie iteratory.
	vector<int> liczby3(liczby1.begin() + 4, liczby1.end() - 2);

	// Indeks:  [0|1|2|3|4|5| 6| 7| 8]
	// Warto: [4|5|6|7|8|9|33|33|33]
	cout << "Liczby3: "; printVector<int>(liczby3);

	// Funkcja pop_back() odrzuca ostatni element.
	// Wywoajmy ja 4 razy.
	for(int i = 0; i < 4; ++i)
		liczby3.pop_back();

	// Indeks:  [0|1|2|3|4]
	// Warto: [4|5|6|7|8]
	cout << "Liczby3: "; printVector<int>(liczby3);

	// Funkcja push_back(val) wrzuca na koniec wartoc val.
	liczby3.push_back(0);
	liczby3.push_back(1);

	// Indeks:  [0|1|2|3|4|5|6]
	// Warto: [4|5|6|7|8|0|1]
	cout << "Liczby3: "; printVector<int>(liczby3);

	return 0;
}